## ovito 2.3.3

=== src/3rdparty/tachyon/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2014) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Build the library.
SET(TACHYON_SOURCE_FILES
	tachyon/api.c
	tachyon/apigeom.c
	tachyon/apitrigeom.c
	tachyon/box.c
	tachyon/camera.c
	tachyon/cone.c
	tachyon/coordsys.c
	tachyon/cylinder.c
	tachyon/extvol.c
	tachyon/global.c
	tachyon/grid.c
	tachyon/hash.c
	tachyon/imap.c
	tachyon/imageio.c
	tachyon/intersect.c	
	tachyon/light.c
	tachyon/parallel.c
	tachyon/plane.c
	tachyon/quadric.c
	tachyon/render.c
	tachyon/ring.c
	tachyon/shade.c
	tachyon/sphere.c
	tachyon/texture.c
	tachyon/threads.c
	tachyon/tgafile.c
	tachyon/sgirgb.c
	tachyon/ppm.c
	tachyon/trace.c
	tachyon/triangle.c
	tachyon/ui.c
	tachyon/util.c
	tachyon/vector.c
	tachyon/vol.c
	tachyon/pngfile.c
	tachyon/jpeg.c
	tachyon/psd.c
	tachyon/winbmp.c
)

# Build library.
ADD_LIBRARY(TachyonLib STATIC ${TACHYON_SOURCE_FILES})

TARGET_COMPILE_DEFINITIONS(TachyonLib PRIVATE TACHYON_NO_DEPRECATED THR _REENTRANT)
IF(APPLE)
	TARGET_COMPILE_DEFINITIONS(TachyonLib PRIVATE Bsd)
ELSEIF(UNIX)
	TARGET_COMPILE_DEFINITIONS(TachyonLib PRIVATE Linux)
	TARGET_COMPILE_OPTIONS(TachyonLib PRIVATE -fPIC)
ELSEIF(WIN32)
	TARGET_COMPILE_DEFINITIONS(TachyonLib PRIVATE WIN32)
ENDIF()

# Make header files of this library available to dependent targets.
TARGET_INCLUDE_DIRECTORIES(TachyonLib INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

IF(APPLE)
	# Link to Pthreads multi-threading library on MacOS.
	TARGET_LINK_LIBRARIES(TachyonLib pthread)
ELSEIF(WIN32)
	# Link to ws2_32 library on Windows.
	TARGET_LINK_LIBRARIES(TachyonLib ws2_32)
ENDIF()

=== src/plugins/crystalanalysis/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Link CGAL library.
INCLUDE(${CGAL_USE_FILE})
IF(NOT CMAKE_COMPILER_IS_GNUCXX)
	ADD_DEFINITIONS(-DCGAL_CFG_ARRAY_MEMBER_INITIALIZATION_BUG)
ENDIF()

SET(OVITO_CRYSTALANALYSIS_SOURCE_FILES
	importer/CAImporter.cpp
	data/patterns/BurgersVectorFamily.cpp
	data/patterns/StructurePattern.cpp
	data/patterns/PatternCatalog.cpp
	data/clusters/Cluster.cpp
	data/clusters/ClusterGraph.cpp
	data/dislocations/DislocationSegment.cpp
	data/dislocations/DislocationNetwork.cpp
	data/dislocations/DislocationDisplay.cpp
	data/dislocations/DislocationInspector.cpp
	modifier/ShiftModifier.cpp
	modifier/SmoothSurfaceModifier.cpp
	modifier/SmoothDislocationsModifier.cpp
	modifier/ConstructSurfaceModifier.cpp
	util/DelaunayTessellation.cpp
)

# Generate plugin module.
OVITO_PLUGIN(CrystalAnalysis
	SOURCES ${OVITO_CRYSTALANALYSIS_SOURCE_FILES}
	PLUGIN_DEPENDENCIES Particles
	LIB_DEPENDENCIES ${CGAL_LIBRARIES} ${CGAL_3RD_PARTY_LIBRARIES} ${OPENGL_gl_LIBRARY}
)

=== debian/changelog ===
ovito (2.3.3-3+deb8u1) jessie-security; urgency=high

  * Non-maintainer upload.
  * No-change rebuild against botan1.10.

 -- Markus Koschany <apo@debian.org>  Tue, 10 May 2016 18:47:53 +0200

ovito (2.3.3-3) unstable; urgency=medium

  * [63c2552] Disable statistic send to a server by default.
  * [5a5813b] Fix nested examples directory.
  * [6f3ff37] Remove all .DS_Store.gz from ovito-doc.

 -- Anton Gladky <gladk@debian.org>  Thu, 24 Jul 2014 23:17:04 +0200

ovito (2.3.3-2) unstable; urgency=medium

  * [a1a602a] Update list of archs.

 -- Anton Gladky <gladk@debian.org>  Fri, 30 May 2014 09:25:51 +0200

ovito (2.3.3-1) unstable; urgency=medium

  * [ed9fe66] Provide ovito-examples by ovito-doc.
  * [c0c572b] Build ovito only on 
              any-amd64 any-i386 any-powerpc any-s390 any-mips.
  * [942ec5a] Imported Upstream version 2.3.3
  * [0fcba66] Ignore quilt dir
  * [0a00c0f] Install examples.
  * [1338fab] Add build-dependency on libswscale-dev.
  * [27c62d4] Fix build-options in debian/rules. 
              Thanks to Moritz Muehlenhoff <jmm@debian.org>. (Closes: #748157)

 -- Anton Gladky <gladk@debian.org>  Thu, 29 May 2014 21:58:42 +0200

ovito (2.3.3~beta1~git7e66e42-1) unstable; urgency=medium

  * [ce147a6] Disable Tachyon on powerpc.
  * [7003db6] Do not build CRYSTALANALYSIS on armel because of absent cgal.
  * [aa60949] Imported Upstream version 2.3.3~beta1~git7e66e42. 
              (Closes: #745668)

 -- Anton Gladky <gladk@debian.org>  Tue, 29 Apr 2014 20:49:51 +0200

ovito (2.3.2~git8178817e-2) unstable; urgency=medium

  * [b124370] Enable TACHYON again, disable it only on kfreebsd*.
  * [3029a45] Do not build tachyon on hurd-i386.
  * [40e2052] Remove libcgal-dev from BD on armel.
  * [47fa8cb] Add libglu1-mesa-dev and libgl1-mesa-dev 
              on armel and armhf to let it build there.
  * [b9e62be] Add dummy autotest.

 -- Anton Gladky <gladk@debian.org>  Fri, 11 Apr 2014 20:04:52 +0200

ovito (2.3.2~git8178817e-1) unstable; urgency=medium

  * [106c6b6] Imported Upstream version 2.3.2~git8178817e
  * [5e86b4f] Remove patches, applied by upstream.
  * [c5f1b03] Add some more packages in Build-Depends.

 -- Anton Gladky <gladk@debian.org>  Tue, 08 Apr 2014 23:46:34 +0200

ovito (2.2.4-2) unstable; urgency=medium

  * [782d8bc] Disable Tachyon plugin. FTBFS on many platforms.
  * [cf6ad96] Disable including cpuid.h as it is absent on some archs.
  * [6190d35] Use packaged muparser instead of embedded version.
  * [27aaf43] Ignore quilt dir.

 -- Anton Gladky <gladk@debian.org>  Mon, 07 Apr 2014 21:11:23 +0200

ovito (2.2.4-1) unstable; urgency=medium

  * [80c58ad] Imported Upstream version 2.2.4. (Closes: #740549)
  * [d81a0f1] Update build-depends, remove ovito-examples binary.
  * [d7e65d7] Remove patches.
  * [23c5984] Add pixmaps.

 -- Anton Gladky <gladk@debian.org>  Sun, 16 Mar 2014 15:24:24 +0100

=== debian/control ===
Source: ovito
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Anton Gladky <gladk@debian.org>
Build-Depends:
 cmake,
 debhelper (>= 9),
 docbook-xml,
 docbook-xsl,
 docbook-xsl-doc-html,
 libavcodec-dev,
 libavdevice-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libboost-python-dev,
 libbotan1.10-dev,
 libcgal-dev [!armel],
 libglu1-mesa-dev [armel armhf],
 libgl1-mesa-dev [armel armhf],
 libgsl0-dev,
 libhdf5-dev,
 libmuparser-dev (>= 2.1.0),
 libnetcdf-dev,
 libqscintilla2-dev,
 libqt5opengl5-dev,
 libqcustomplot-dev (>=1.2.0),
 libswscale-dev,
 libtachyon-dev [!hurd-i386],
 python-dev,
 qt5-default,
 qtbase5-dev-tools,
 qtscript5-dev,
 xsltproc,
 zlib1g-dev
Standards-Version: 3.9.5
XS-Testsuite: autopkgtest
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ovito.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ovito.git
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any-amd64 any-i386 any-powerpc s390x mips mipsel
Depends:
 python,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 ovito-doc
Suggests:
 povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Depends:
 ${misc:Depends}
Provides:
 ovito-examples
Suggests:
 ovito,
Section: doc
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel

extra_flags += \
	-DOVITO_BUILD_DOCUMENTATION=TRUE \
	-DOVITO_BUILD_PLUGIN_SCRIPTING=TRUE \
	-DOVITO_BUILD_PLUGIN_NETCDF=TRUE \
	-DOVITO_VIDEO_OUTPUT_SUPPORT=ON \
	-DOVITO_USE_SYSTEM_QCUSTOMPLOT=ON

ifneq (,$(filter $(DEB_HOST_ARCH), kfreebsd-amd64 kfreebsd-i386 hurd-i386 powerpc))
	extra_flags += -DOVITO_BUILD_PLUGIN_TACHYON=FALSE
endif

ifeq (,$(filter $(DEB_HOST_ARCH), armel))
	extra_flags += -DOVITO_BUILD_PLUGIN_CRYSTALANALYSIS=TRUE
endif

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_install:
	dh_install --list-missing
	find ./debian/ovito -type d -empty -delete
	find ./ -name "*DS_Store.gz" | xargs rm -f

## ovito 2.3.3%2Bdfsg1

=== CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2013) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

PROJECT(Ovito)

# Make sure we have a recent version of CMake.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.12 FATAL_ERROR)

# Automatically link to qtmain.lib on Windows.
IF(WIN32)
	CMAKE_POLICY(SET CMP0020 NEW)
ENDIF()

GET_FILENAME_COMPONENT(OVITO_SOURCE_BASE_DIR ${CMAKE_CURRENT_LIST_FILE} PATH)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${OVITO_SOURCE_BASE_DIR}/cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/Version.cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/Plugins.cmake)
INCLUDE(${OVITO_SOURCE_BASE_DIR}/cmake/CompileQtResource.cmake)

# Add options that control the building of plugins.
OPTION(OVITO_BUILD_PLUGIN_PARTICLES "Build the Particles plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_MESH "Build the Mesh plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_TACHYON "Build the Tachyon plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS "Build the CrystalAnalysis plugin." "OFF")
OPTION(OVITO_BUILD_PLUGIN_SCRIPTING "Build the Scripting plugin." "ON")
OPTION(OVITO_BUILD_PLUGIN_NETCDF "Build the NetCDF plugin." "OFF")

# Tell CMake to run Qt moc when necessary:
SET(CMAKE_AUTOMOC ON)
# As moc files are generated in the binary dir, tell CMake to always look for includes there:
SET(CMAKE_INCLUDE_CURRENT_DIR ON)
  
# Find and setup Qt5 libraries.
SET(OVITO_REQUIRED_QT_MODULES Core Gui Widgets Xml OpenGL Concurrent Network PrintSupport)
IF(OVITO_BUILD_PLUGIN_SCRIPTING)
	LIST(APPEND OVITO_REQUIRED_QT_MODULES Script)
ENDIF()
FOREACH(COMPONENT ${OVITO_REQUIRED_QT_MODULES})
	FIND_PACKAGE(Qt5${COMPONENT} REQUIRED)
ENDFOREACH()

# Find OpenGL library.
FIND_PACKAGE(OpenGL REQUIRED)

# Find the ZLib library.
FIND_PACKAGE(ZLIB REQUIRED)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})

# Find the CGAL library.
IF(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS)
	FIND_PACKAGE(CGAL REQUIRED)
ENDIF()

# Define the OVITO_DEBUG macro in debug builds.
SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DOVITO_DEBUG")

# Enable C++11 standard.
IF(NOT MSVC)
	IF(CMAKE_COMPILER_IS_GNUCXX)
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
	ELSE()
		SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
	ENDIF()
ENDIF()
IF(APPLE)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++ -Wno-invalid-offsetof")
ENDIF()

# Enable additional optimizations for release builds.
#IF(CMAKE_COMPILER_IS_GNUCXX)
#	# Use -flto flag to enable GCC's link-time optimization.
#	SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -flto -fuse-linker-plugin")
#	SET(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} -flto -fuse-linker-plugin")
#	SET(CMAKE_MODULE_LINKER_FLAGS_RELEASE "${CMAKE_MODULE_LINKER_FLAGS_RELEASE} -flto -fuse-linker-plugin")
#ENDIF()

# This is the base directory for all included header files.
INCLUDE_DIRECTORIES("${OVITO_SOURCE_BASE_DIR}/src")

# Static or shared (and extensible) version of Ovito?
OPTION(OVITO_MONOLITHIC_BUILD "Create one big executable that contains all plugins and third-party libraries." "OFF")

IF(UNIX)
	IF(APPLE)
		SET(MACOSX_BUNDLE_NAME "Ovito") 
		SET(MACOSX_BUNDLE_BUNDLE_NAME "${MACOSX_BUNDLE_NAME}") 
		
		# The directory where the main executable goes to.
		SET(OVITO_RELATIVE_BINARY_DIRECTORY ".")
		# The directory where the main libraries go to.
		SET(OVITO_RELATIVE_LIBRARY_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/MacOS")
		# The directory where the auxiliary files go to.
		SET(OVITO_RELATIVE_SHARE_DIRECTORY "${MACOSX_BUNDLE_NAME}.app/Contents/Resources")
		# The directory where the compiled plugins go to.
		SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins")	
	ELSE(APPLE)
		# The directory where the main executable goes to.
		SET(OVITO_RELATIVE_BINARY_DIRECTORY "bin")
		# The directory where the main libraries go to.
		SET(OVITO_RELATIVE_LIBRARY_DIRECTORY "lib/ovito")
		# The directory where the auxiliary files go to.
		SET(OVITO_RELATIVE_SHARE_DIRECTORY "share/ovito")
		# The directory where the compiled plugins go to.
		SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins")
	ENDIF(APPLE)
ELSE(UNIX)
	# The directory where the main executable goes to.
	SET(OVITO_RELATIVE_BINARY_DIRECTORY ".")
	# The directory where the main libraries go to.
	SET(OVITO_RELATIVE_LIBRARY_DIRECTORY ".")
	# The directory where the auxiliary files go to.
	SET(OVITO_RELATIVE_SHARE_DIRECTORY ".")
	# The directory where the compiled plugins go to.
	SET(OVITO_RELATIVE_PLUGINS_DIRECTORY "${OVITO_RELATIVE_LIBRARY_DIRECTORY}/plugins")
ENDIF(UNIX)

# If a monothlitic build is enabled, a single static executable is created that contains all plugins.
# Otherwise the plugin and core libraries are created as shared objects. This is the default.
IF(OVITO_MONOLITHIC_BUILD)
	
	# Creating a static executable has only been tested for Linux systems.
	IF(NOT UNIX OR APPLE OR NOT CMAKE_COMPILER_IS_GNUCXX)
		MESSAGE(FATAL_ERROR "Creating a static executable is only supported on Linux using the GCC compiler. Please set OVITO_MONOLITHIC_BUILD to OFF.")
	ENDIF(NOT UNIX OR APPLE OR NOT CMAKE_COMPILER_IS_GNUCXX)

	# Create .a libraries.
	SET(BUILD_SHARED_LIBS "OFF")

	# Let the source code know that we're building a monolithic executable without
	# plugins residing in shared libraries.
	ADD_DEFINITIONS(-DOVITO_MONOLITHIC_BUILD)

ELSE(OVITO_MONOLITHIC_BUILD)

	# Create .so libraries.
	SET(BUILD_SHARED_LIBS "ON")

	# Setup RPATH
	SET(CMAKE_SKIP_BUILD_RPATH FALSE)
	# When building, use the install RPATH already
	SET(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
	# The RPATH to be used when building and installing
	SET(CMAKE_INSTALL_RPATH "\$ORIGIN/../lib/ovito")
	# add the automatically determined parts of the RPATH
	# which point to directories outside the build tree to the install RPATH
	SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

ENDIF(OVITO_MONOLITHIC_BUILD)

# The directory where the main executable goes to.
SET(OVITO_BINARY_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_BINARY_DIRECTORY}")
# The directory where the main libraries go to.
SET(OVITO_LIBRARY_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_LIBRARY_DIRECTORY}")
# The directory where the compiled plugins go to.
SET(OVITO_PLUGINS_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_PLUGINS_DIRECTORY}")
# The directory where the auxiliary files go to.
SET(OVITO_SHARE_DIRECTORY "${${PROJECT_NAME}_BINARY_DIR}/${OVITO_RELATIVE_SHARE_DIRECTORY}")

# Our installation path.
SET(OVITO_CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})

# Add the plugins directory to the library path. Some plugins may link against other plugins.
LINK_DIRECTORIES(${OVITO_PLUGINS_DIRECTORY})

# Controls compilation of the video encoding module.
OPTION(OVITO_VIDEO_OUTPUT_SUPPORT "Build the video encoding module." "OFF")
IF(OVITO_VIDEO_OUTPUT_SUPPORT)
	ADD_DEFINITIONS(-DOVITO_VIDEO_OUTPUT_SUPPORT)
ENDIF()

# Build program.
ADD_SUBDIRECTORY(src)

# On Windows, the third-party library DLLs are not part of the system. 
# We need to install them in the OVITO directory.
IF(WIN32)
	# Gather Qt dynamic link libraries.
	FOREACH(COMPONENT ${OVITO_REQUIRED_QT_MODULES})
		GET_TARGET_PROPERTY(dll Qt5::${COMPONENT} LOCATION_${CMAKE_BUILD_TYPE})
		LIST(APPEND REQUIRED_DLLS "${dll}")
		IF(${COMPONENT} MATCHES "Core")
			GET_FILENAME_COMPONENT(QtBinaryPath ${dll} PATH)
			IF(CMAKE_SIZEOF_VOID_P EQUAL 8)
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/icudt52.dll")		
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/icuin52.dll")		
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/icuuc52.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libharfbuzz-0.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libfreetype-6.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libpcre16-0.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/zlib1.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libbz2-1.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libglib-2.0-0.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libintl-8.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libpng16-16.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libiconv-2.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libjpeg-8.dll")
			ELSE()
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/icudt51.dll")		
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/icuin51.dll")		
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/icuuc51.dll")
			ENDIF()
			IF(MINGW)
				# 32-bit and 64-bit MinGW use different exception models and must link different
				# libgcc_s variants.
				IF(CMAKE_SIZEOF_VOID_P EQUAL 8)
					LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libgcc_s_seh-1.dll")
				ELSE()
					LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libgcc_s_dw2-1.dll")
				ENDIF()
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libstdc++-6.dll")
				LIST(APPEND REQUIRED_DLLS "${QtBinaryPath}/libwinpthread-1.dll")
			ENDIF()
		ENDIF()
	ENDFOREACH()
	
	# Install Qt plugins.
	IF(CMAKE_BUILD_TYPE STREQUAL "Debug")
		INSTALL(FILES "${QtBinaryPath}/../plugins/platforms/qwindowsd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/platforms/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qjpegd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/accessible/qtaccessiblewidgetsd.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/accessible/")
	ELSE()
		INSTALL(FILES "${QtBinaryPath}/../plugins/platforms/qwindows.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/platforms/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/imageformats/qjpeg.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/imageformats/")
		INSTALL(FILES "${QtBinaryPath}/../plugins/accessible/qtaccessiblewidgets.dll" DESTINATION "${OVITO_RELATIVE_BINARY_DIRECTORY}/plugins/accessible/")
	ENDIF()
	
	# Install a qt.conf file.
	INSTALL(CODE "
	    file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${OVITO_RELATIVE_BINARY_DIRECTORY}/qt.conf\" \"[Paths]\\nPlugins = plugins/\")
	    " COMPONENT Runtime)
		
	# Install zlib DLL.
	LIST(GET ZLIB_LIBRARIES 0 ZLIB_FIRST_LIBRARY)
	GET_FILENAME_COMPONENT(ZLIB_LIBRARY_PATH "${ZLIB_FIRST_LIBRARY}" PATH)
	SET(ZLIB_DLL_PATH "${ZLIB_LIBRARY_PATH}/../bin" CACHE PATH "Directory where the ZLib dll is located.")
	MARK_AS_ADVANCED(ZLIB_DLL_PATH)
	LIST(APPEND REQUIRED_DLLS "${ZLIB_DLL_PATH}/libzlib.dll")

	# Install libav DLLS.
	IF(OVITO_VIDEO_OUTPUT_SUPPORT)
		SET(LIBAV_DLLS avcodec-55.dll avdevice-54.dll avformat-55.dll avutil-52.dll libmp3lame-0.dll
						libogg-0.dll librtmp.dll libvo-aacenc-0.dll libvorbis-0.dll libvorbisenc-2.dll 
						libvorbisfile-3.dll libx264-118.dll libx264-125.dll swscale-2.dll)
		FOREACH(dll ${LIBAV_DLLS})
			LIST(APPEND REQUIRED_DLLS "${FFMPEG_LIBRARY_DIR}/../bin/${dll}")
		ENDFOREACH()
	ENDIF()
	
	# Install CGAL, GMP, MPFR, and Boost DLLs.
	IF(OVITO_BUILD_PLUGIN_CRYSTALANALYSIS)
		LIST(APPEND REQUIRED_DLLS ${CGAL_LIBRARY})
		IF(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
			LIST(APPEND REQUIRED_DLLS ${GMP_LIBRARIES})
			LIST(APPEND REQUIRED_DLLS ${MPFR_LIBRARIES})
		ENDIF()
		LIST(APPEND REQUIRED_DLLS "${CGAL_3RD_PARTY_LIBRARIES_DIRS}/libboost_thread-mt.dll")

=== src/plugins/netcdf/CMakeLists.txt ===
###############################################################################
# 
#  Copyright (2012) Alexander Stukowski
#
#  This file is part of OVITO (Open Visualization Tool).
#
#  OVITO is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  OVITO is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############################################################################

# Locate the NetCDF library and headers.
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})
FIND_PACKAGE(NetCDF REQUIRED)
IF(NOT NETCDF_FOUND)
	MESSAGE(FATAL_ERROR "NetCDF library not found on your system.")
ENDIF(NOT NETCDF_FOUND)
INCLUDE_DIRECTORIES(${NETCDF_INCLUDE_DIRS})

# Locate the HDF5 library.
IF(OVITO_MONOLITHIC_BUILD)
	SET(HDF5_USE_STATIC_LIBRARIES TRUE)
ENDIF()
FIND_PACKAGE(HDF5 COMPONENTS C HL REQUIRED)
IF(NOT HDF5_FOUND)
	MESSAGE(FATAL_ERROR "HDF5 library not found on your system.")
ENDIF(NOT HDF5_FOUND)

IF(WIN32)
	# Locate HDF5 DLLs
	LIST(GET HDF5_LIBRARIES 0 HDF5_FIRST_LIBRARY)
	GET_FILENAME_COMPONENT(HDF5_LIBRARY_PATH "${HDF5_FIRST_LIBRARY}" PATH)
	SET(HDF5_DLL_PATH "${HDF5_LIBRARY_PATH}/../bin" CACHE PATH "Directory where the HDF5 dlls are located.")
	MARK_AS_ADVANCED(HDF5_DLL_PATH)

	# Locate NetCDF DLL
	LIST(GET NETCDF_LIBRARIES 0 NETCDF_FIRST_LIBRARY)
	GET_FILENAME_COMPONENT(NETCDF_LIBRARY_PATH "${NETCDF_FIRST_LIBRARY}" PATH)
	SET(NETCDF_DLL_PATH "${NETCDF_LIBRARY_PATH}/../bin" CACHE PATH "Directory where the NetCDF dll is located.")
	MARK_AS_ADVANCED(NETCDF_DLL_PATH)
ENDIF()

# Also find the auxiliary SZIP library that comes with the HDF5 distribution.
#IF(WIN32)
#	FIND_LIBRARY(HDF5_SZIP_LIBRARY NAMES szip HINTS ${HDF5_LIBRARY_DIRS} ENV HDF5_ROOT PATH_SUFFIXES lib Lib)
#ENDIF(WIN32)

SET(OVITO_NETCDF_SOURCE_FILES
	NetCDFImporter.cpp
)

# Generate plug-in module.
OVITO_PLUGIN(
	NetCDFImporter
	SOURCES ${OVITO_NETCDF_SOURCE_FILES}
	PLUGIN_DEPENDENCIES Particles
	LIB_DEPENDENCIES ${NETCDF_LIBRARIES} ${HDF5_LIBRARIES} ${HDF5_SZIP_LIBRARY}
)

=== debian/control ===
Source: ovito
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: science
Testsuite: autopkgtest
Priority: extra
Build-Depends: cmake,
               debhelper (>= 9),
               docbook-xml,
               docbook-xsl,
               docbook-xsl-doc-html,
               libavcodec-dev,
               libavdevice-dev,
               libboost-dev,
               libboost-iostreams-dev,
               libboost-python-dev,
               libbotan1.10-dev,
               libcgal-qt5-dev [!armel],
               libglu1-mesa-dev [armel armhf],
               libgl1-mesa-dev [armel armhf],
               libgsl0-dev,
               libhdf5-dev,
               libmuparser-dev (>= 2.1.0),
               libnetcdf-dev,
               libqscintilla2-dev,
               libqt5opengl5-dev,
               libqcustomplot-dev,
               libswscale-dev,
               python-dev,
               qtbase5-dev-tools,
               qtscript5-dev,
               xsltproc,
               zlib1g-dev
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ovito.git
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ovito.git
Homepage: http://www.ovito.org/

Package: ovito
Architecture: any
Depends: python,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ovito-doc
Suggests: povray
Description: visualization and analysis tool for atomistic simulation data
 OVITO is a visualization and analysis software for atomistic
 simulation data. Being a single integrated application it covers both
 the analysis and the visualization of large-scale atomistic datasets
 produced by molecular dynamics/statics and Monte-Carlo simulation
 codes. Its name is an acronym for Open Visualization Tool,
 emphasizing that the software has been designed with flexibility and
 extensibility in mind.

Package: ovito-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: ovito
Provides: ovito-examples
Description: documentation for ovito
 OVITO aka Open Visualization Tool is a scientific visualization and
 analysis software for atomistic simulation data.
 .
 This package contains the User Manual for ovito.
